// "Compiled" news ticker lib
(function(e){e.fn.inewsticker=function(t){var n={speed:200,effect:"fade",dir:"ltr",font_size:null,color:null,font_family:null,delay_after:3e3};
e.extend(n,t);var r=e(this);var i=r.children();i.not(":first").hide();r.css("direction",t.dir);r.css("font-size",t.font_size);
r.css("color",t.color);r.css("font-family",t.font_family);setInterval(function(){var e=r.children();e.not(":first").hide();
var n=e.eq(0);var i=e.eq(1);if(t.effect=="slide"){n.slideUp();i.slideDown(function(){n.remove().appendTo(r)})}
if(t.effect=="fade"){n.fadeOut(function(){i.fadeIn();n.remove().appendTo(r)})}},t.speed);if(t.effect=="typing"){
var s=0;var o=0;var u=t.delay_after/t.speed;var a=(new Array(1+u)).join(" ");var f=new Array;i.each(function(){f.push(e(this).text()+a)});
count=f.length;setInterval(function(){result=f[o].substring(0,s);e(r).html(result);s++;if(s==f[o].length){
s=0;r.appendTo(r).hide().fadeIn("slow");o++;if(count==o){o=0}}},t.speed)}}})(jQuery);

function capitalizeFirstLetter(string)
{
    return string.charAt(0).toUpperCase() + string.slice(1);
}

function getCrumbTitle(str)
{
    str = str.split('.')[0];
    var words = str.split('-');
    var t = "";

    for(w in words)
    {
        t += capitalizeFirstLetter(words[w]) + " ";
    }

    return t;
}

function generateBreadcrumbs()
{
    var $bc = $('#breadcrumbs');
    if($bc.length){
        var o = window.location.origin;
        var paths = window.location.pathname.split('/');
        paths.shift();
        var html = '<a href="/">Home</a>';
        for(p in paths){
            if(paths[p] !== ''){
                html += ' &raquo; ';
                html += '<a href="' + (function(){
                    var url = o;
                    for(var i = 0; i <= p; i++){
                        url += '/' + paths[i];
                    }
                    return url;
                })() + '">' + getCrumbTitle(paths[p]) + '</a>';
            }
        }
        $bc.html(html);
    }
}

// Put function declarations below this line
function addExternalClasses()
{
    $('a:external').addClass('external');
    $('.external').each(function(key, val){

        //if this link has child class of .news-link, append the icon inside of that span
        var nl = $(val).find(".news-link");
        if(nl.length !== 0)
        {
            nl.append('<i class="fas fa-external-link-alt ml-1 external-link"></i>');
        }
        else
        {
            $(val).append('<i class="fas fa-external-link-alt ml-1 external-link"></i>');
        }

    });

    // Add specific icon classes to links to documents
    $('a[href$=".pdf"],.pdf').addClass("pdf");
    $('.pdf').each(function(key, val){

        var nl = $(val).find(".news-link");
        if(nl.length !== 0)
        {
            nl.append('<span class="pdf-label" aria-hidden="true"><b class="hide">PDF Document</b></span>');
        }
        else
        {
            $(val).append('<span class="pdf-label" aria-hidden="true"><b class="hide">PDF Document</b></span>');
        }

    });


    $("a[href$='.xls'], a[href$='.xlsx'],.xls").addClass("xls");
    $('.xls').each(function(key, val){

        var nl = $(val).find(".news-link");
        if(nl.length !== 0)
        {
            nl.append("<span class='xls-label' aria-hidden='true'><b class='hide'>Excel Spreadsheet</b></span>");
        }
        else
        {
            $(val).append("<span class='xls-label' aria-hidden='true'><b class='hide'>Excel Spreadsheet</b></span>");
        }

    });


    $("a[href$='.doc'], a[href$='.docx'], a[href$='.txt'],.doc").addClass("doc");
    $('.doc').each(function(key, val){

        var nl = $(val).find(".news-link");
        if(nl.length !== 0)
        {
            nl.append("<span class='doc-label' aria-hidden='true'><b class='hide'>Word Document</b></span>");
        }
        else
        {
            $(val).append("<span class='doc-label' aria-hidden='true'><b class='hide'>Word Document</b></span>");
        }

    });


    $("a[href$='.ppt'], a[href$='.pptx'],.ppt").addClass("ppt");
    $('.ppt').each(function(key, val){

        var nl = $(link).find(".news-link");
        if(nl.length !== 0)
        {
            nl.append("<span class='ppt-label' aria-hidden='true'><b class='hide'>Powerpoint Presentation</b></span>");
        }
        else
        {
            $(val).append("<span class='ppt-label' aria-hidden='true'><b class='hide'>Powerpoint Presentation</b></span>");
        }

    });


    $("a[href$='.zip'], a[href$='.gzip'], a[href$='.rar'],.zip").addClass("zip");
    $('.zip').each(function(){

        var nl = $(val).find(".news-link");
        if(nl.length !== 0)
        {
            nl.append("<span class='zip-label' aria-hidden='true'><b class='hide'>Compressed Archive</b></span>");
        }
        else
        {
            $(val).append("<span class='zip-label' aria-hidden='true'><b class='hide'>Compressed Archive</b></span>");
        }

    });


    $("a[href$='.xml'],.xml").addClass("xml");
    $('.xml').each(function(){

        var nl = $(val).find(".news-link");
        if(nl.length !== 0)
        {
            nl.append("<span class='xml-label' aria-hidden='true'><b class='hide'>XML Document</b></span>");
        }
        else
        {
            $(val).append("<span class='xml-label' aria-hidden='true'><b class='hide'>XML Document</b></span>");
        }

    });

}

$(document).ready(function(){
	
	// Put code that must run after page load here

    /* Enable popovers and tooltips
    **********************************************************/
    $('[data-toggle="popover"]').popover();
    $('[data-toggle="tooltip"]').tooltip();

    /* Switch accordion arrows
    **********************************************************/
    $('.accordion').on("click", ".card-header", function(){

        var clickedHeader = this;

        $(".accordion-arrows i", this).each(function(key, val){

            var $i = $(val);
            if($i.hasClass("hide"))
            {
                $i.removeClass("hide");
            }
            else
            {
                $i.addClass("hide");
            }

        });

        $(".card-header").each(function(key, val){

            if(val !== clickedHeader)
            {
                $(".accordion-arrows i", val).each(function(key, val2){

                    let $i = $(val2);
                    if($i.hasClass("fa-angle-up") && !$i.hasClass("hide"))
                    {
                        $i.addClass("hide");
                    }
                    if($i.hasClass("fa-angle-down"))
                    {
                        $i.removeClass("hide");
                    }

                });


            }

        });



    });


    // obtain the hyperlink whitelist, add required classes to all hyperlinks
    $.getJSON("/js/hyperlink-whitelist.json", function(whitelist){

        // Define customer jquery "external" selector
        $.expr[':'].external = function(obj){
            for(i in whitelist)
            {
                if(obj.href.indexOf(whitelist[i]) > -1)
                {
                    return false;
                }
            }
            return true;
        };

        addExternalClasses();

        // remove external link classes from elements where they are obtrusive
        $("a.external:has(img) .external-link, #connect:has('.external') .external-link, #toolbar:has('.external') .external-link, a.pdf:has(img) .pdf-label, a.pdf:has(button) .pdf-label, button:has(a) .pdf-label, a.xls:has(img) .xls-label, a.doc:has(img) .doc-label, .share-container ul li .external-link, a.rss .xml-label").remove();

    });


    // what happens when an external class is clicked
    $('a.external').click(function(e){

        let link = $(this).attr('href');

        e.preventDefault();

        $('#externalLinkModalMessageUrl').html(link);
        $('#externalLinkModalAnchor').attr('href', link);

        $('#externalLinkModal').modal("show");

    });

    // add breadcrumbs
    generateBreadcrumbs();

    // enable news tickers
    $('.news li').show();

    $('.news').inewsticker({
        speed       : 3200,
        effect      : 'fade',
        dir         : 'ltr',
        font_size   : 13,
        color       : '#fff',
        font_family : 'arial',
        delay_after : 1000
    });
	
	
});